﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter1
{
    class Item07
    {
        public static void Tests()
        {
            var aPoint = (X: 5, Y: 67);
            Console.WriteLine(aPoint.X);

            // another point has fields 'X' and 'Y'
            var anotherPoint = aPoint;

            // pointThree has fields 'Rise' and 'Run'
            (int Rise, int Run) pointThree = aPoint;
        }

        private static void AnonymousMumble()
        {
            var aPoint = new { X = 5, Y = 67 };
            var anotherPoint = Transform(aPoint, (p) =>
                new { X = p.X * 2, Y = p.Y * 2 });
        }

        private static void AnonymousTwo()
        {
            var aPoint = new { X = 5, Y = 67 };
            var anotherPoint = new { Y = 12, X = 16 };

        }

        private static void QuerySTuff()
        {
            var customers = new List<(string SalesRepresentative, int ZipCode)>();
            var query = from c in customers
                        group c by new { c.SalesRepresentative, c.ZipCode };

        }

        static T Transform<T>(T element, Func<T, T> transformFunc)
        {
            return transformFunc(element);
        }

    }

    internal sealed class AnonymousMumbleMumble
    {
        private readonly int x;

        public int X
        {
            get { return X; }
        }

        private readonly int y;
        public int Y
        {
            get { return y; }
        }

        public AnonymousMumbleMumble(int xParm, int yParm)
        {
            x = xParm;
            y = yParm;
        }
    }

}
