﻿using Microsoft.Office.Interop.Word;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    class Item12
    {
        public static void Tests()
        {
        }

        private void Test()
        { 
            SetName(lastName: "Wagner", firstName: "Bill");
        }

        private static void SnippetOne()
        {
            var wasted = Type.Missing;
            var wordApp = new
                Microsoft.Office.Interop.Word.Application();
            wordApp.Visible = true;
            Documents docs = wordApp.Documents;

            Document doc = docs.Add(ref wasted,
                ref wasted, ref wasted, ref wasted);

            Range range = doc.Range(0, 0);

            range.InsertAfter("Testing, testing, testing. . .");

        }

        private static void SnippetTwo()
        {
            var wordApp = new
                Microsoft.Office.Interop.Word.Application();
            wordApp.Visible = true;
            Documents docs = wordApp.Documents;

            Document doc = docs.Add();

            Range range = doc.Range(0, 0);

            range.InsertAfter("Testing, testing, testing. . .");
        }

        private static void SnippetThree()
        {
            var wordApp = new
                Microsoft.Office.Interop.Word.Application();
            wordApp.Visible = true;
            Documents docs = wordApp.Documents;

            object docType = WdNewDocumentType.wdNewWebPage;
            Document doc = docs.Add(DocumentType: ref docType);

            Range range = doc.Range(0, 0);

            range.InsertAfter("Testing, testing, testing. . .");
        }

        private void SetName(string lastName, string firstName)
        {
            // elided
        }

    }

    public class More
    {
        public void SetName(string Last, string First)
        { }
    }
}
