﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter3_Task
{
    class Item32
    {
        public static void Tests()
        {

        }

        private DateTime startDate;
        private DateTime endDate;
        private List<WeatherData> recentObservations = new List<WeatherData>();
        private DateTime lastReading;
        public ValueTask<IEnumerable<WeatherData>> 
            RetrieveHistoricalData()
        {
            if (DateTime.Now - lastReading > TimeSpan.FromMinutes(5))
            {
                return new ValueTask<IEnumerable<WeatherData>>(recentObservations);
            }
            else
            {
                async Task<IEnumerable<WeatherData>> loadCache()
                {
                    recentObservations = new List<WeatherData>();
                    var observationDate = this.startDate;
                    while (observationDate < this.endDate)
                    {
                        var observation = await RetrieveObservationData(observationDate);
                        recentObservations.Add(observation);
                        observationDate += TimeSpan.FromDays(1);
                    }
                    lastReading = DateTime.Now;
                    return recentObservations;
                }
                return new ValueTask<IEnumerable<WeatherData>>(loadCache());
            }
        }

        private Task<WeatherData> RetrieveObservationData(DateTime observationDate)
        {
            throw new NotImplementedException();
        }
    }

    public class WeatherData
    {
    }
}
