﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace Chapter3_Task
{
    class Item29
    {
        public static void Tests()
        {
        }

        public static async Task<XElement> ReadPacket(string Url)
        {
            var result = await DownloadAsync(Url).ConfigureAwait(continueOnCapturedContext: false);
            return XElement.Parse(result);
        }

        private static Task<string> DownloadAsync(string url)
        {
            return Task.FromResult("<Stuff>things</Stuff");
        }

        public static async Task<Config> ReadConfig(string Url)
        {
            var result = await DownloadAsync(Url)
                .ConfigureAwait(continueOnCapturedContext: false);
            var items = XElement.Parse(result);
            var userConfig = from node in items.Descendants()
                             where node.Name == "Config"
                             select node.Value;
            var configUrl = userConfig.SingleOrDefault();
            if (configUrl != null)
            {
                result = await DownloadAsync(configUrl)
                    .ConfigureAwait(continueOnCapturedContext: false);
                var config = await ParseConfig(result)
                    .ConfigureAwait(continueOnCapturedContext: false);
                return config;
            }
            else
                return new Config();
        }

        private static Task<Config> ParseConfig(string result)
        {
            return Task.FromResult(new Config());
        }

        /*
        private async void OnCommand(object sender, RoutedEventArgs e)
        {
            var viewModel = (DataContext as SampleViewModel);
            try
            {
                var userInput = viewModel.webSite;
                var result = await DownloadAsync(userInput);
                var items = XElement.Parse(result);
                var userConfig = from node in items.Descendants()
                                 where node.Name == "Config"
                                 select node.Value;
                var configUrl = userConfig.SingleOrDefault();
                if (configUrl != null)
                {
                    result = await DownloadAsync(configUrl)
                        .ConfigureAwait(continueOnCapturedContext: false);
                    var config = await ParseConfig(result)
                        .ConfigureAwait(continueOnCapturedContext: false);
                    await viewModel.Update(config);
                }
                else
                    await viewModel.Update(new Config());
            }
            catch (Exception ex) when (logMessage(viewModel, ex))
            {
            }
        }

        private async void OnCommand(object sender, RoutedEventArgs e)
        {
            var viewModel = (DataContext as SampleViewModel);
            try
            {
                Config config = await ReadConfigAsync(viewModel);
                await viewModel.Update(config);
            }
            catch (Exception ex) when (logMessage(viewModel, ex))
            {
            }
        }

        private async Task<Config> ReadConfigAsync(SampleViewModel viewModel)
        {
            var userInput = viewModel.webSite;
            var result = await DownloadAsync(userInput)
                .ConfigureAwait(continueOnCapturedContext: false);
            var items = XElement.Parse(result);
            var userConfig = from node in items.Descendants()
                             where node.Name == "Config"
                             select node.Value;
            var configUrl = userConfig.SingleOrDefault();
            var config = default(Config);
            if (configUrl != null)
            {
                result = await DownloadAsync(configUrl)
                    .ConfigureAwait(continueOnCapturedContext: false);
                config = await ParseConfig(result)
                    .ConfigureAwait(continueOnCapturedContext: false);
            }
            else
                config = new Config();
            return config;
        }

        private bool logMessage(SampleViewModel viewModel, Exception ex)
        {
            viewModel.Messages.Add(ex.ToString());
            return false;
        }
        */


    }

    public class Config
    {
    }
}
